## openjph 0.21.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.11.0)

## Library name/version
include(ojph_version.cmake)

## project
project (openjph VERSION ${OPENJPH_VERSION} DESCRIPTION "Open source implementation of JPH" LANGUAGES CXX)
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

################################################################################################
# Building OpenJPH
################################################################################################

## Target architecture
# We use the target architecture to help with arranging files in "source_group" commands.
# The code does not use the results provided by target_arch.cmake, and relies, instead, 
# on its own logic, which matches that in target_arch.cmake, to identify the architecture
include(target_arch.cmake)
target_architecture(OJPH_TARGET_ARCH)
message(STATUS "CPU Architecture is ${OJPH_TARGET_ARCH}")

## options
option(BUILD_SHARED_LIBS "Shared Libraries" ON)
option(OJPH_ENABLE_TIFF_SUPPORT "Enables input and output support for TIFF files" ON)
option(OJPH_BUILD_TESTS "Enables building test code" OFF)
option(OJPH_BUILD_EXECUTABLES "Enables building command line executables" ON)
option(OJPH_BUILD_STREAM_EXPAND "Enables building ojph_stream_expand executable" OFF)

option(OJPH_DISABLE_SIMD "Disables the use of SIMD instructions -- agnostic to architectures" OFF)
option(OJPH_DISABLE_SSE "Disables the use of SSE SIMD instructions and associated files" OFF)
option(OJPH_DISABLE_SSE2 "Disables the use of SSE2 SIMD instructions and associated files" OFF)
option(OJPH_DISABLE_SSSE3 "Disables the use of SSSE3 SIMD instructions and associated files" OFF)
option(OJPH_DISABLE_SSE4 "Disables the use of SSE4 SIMD instructions and associated files" OFF)
option(OJPH_DISABLE_AVX "Disables the use of AVX SIMD instructions and associated files" OFF)
option(OJPH_DISABLE_AVX2 "Disables the use of AVX2 SIMD instructions and associated files" OFF)
option(OJPH_DISABLE_AVX512 "Disables the use of AVX512 SIMD instructions and associated files" OFF)
option(OJPH_DISABLE_NEON "Disables the use of NEON SIMD instructions and associated files" OFF)

## options that are being deprecated
if (DEFINED OJPH_DISABLE_INTEL_SIMD)
  message(STATUS "OJPH_DISABLE_INTEL_SIMD is being deprecated. Instead, use \"OJPH_DISABLE_SIMD\", "
                 "which is architecture agnostic. If you do not specify any, the default is "
                 "OJPH_DISABLE_SIMD=OFF.")
  set(OJPH_DISABLE_SIMD ${OJPH_DISABLE_INTEL_SIMD})
  message(STATUS "OJPH_DISABLE_SIMD is set to ${OJPH_DISABLE_SIMD}")  
  unset(OJPH_DISABLE_INTEL_SIMD)  
endif()
if (DEFINED OJPH_ENABLE_INTEL_AVX512)
  message(STATUS "OJPH_ENABLE_INTEL_AVX512 is being deprecated, use \"OJPH_DISABLE_AVX512\" instead."
                 "If you do not specify any, the default is OJPH_DISABLE_AVX512=OFF.")
  if (OJPH_ENABLE_INTEL_AVX512)
    set(OJPH_DISABLE_AVX512 OFF)
  else()
    set(OJPH_DISABLE_AVX512 ON)
  endif()
  message(STATUS "OJPH_DISABLE_AVX512 is set to ${OJPH_DISABLE_AVX512}")  
  unset(OJPH_ENABLE_INTEL_AVX512)
endif()

## Setting some of the options if EMSCRIPTEN is the compiler
# In previous releases, the cmake script used to produce both non-SIMD and 
# SIMD builds in one go.  At the time of this writing, all interpreters and 
# compilers of WASM code, such as web-browser and node, support SIMD, therefore 
# it is time to make the SIMD build the default.  In other words, this cmake 
# script builds only WASM SIMD code by default, if desired, a non-SIMD build
# can be generated using the OJPH_DISABLE_SIMD option (in this case, the 
# WASM SIMD code is not generated).
# It is worth remembering that the SIMD/non-SIMD issue arose because it is
# NOT possible to have multiple execution paths in the code, one for non-SIMD
# and one for SIMD, as we do for CPUs, letting the program select, at run-time, 
# the best path to follow.
if(EMSCRIPTEN)
  set(BUILD_SHARED_LIBS OFF)
  set(OJPH_ENABLE_TIFF_SUPPORT OFF)
  set(OJPH_BUILD_STREAM_EXPAND OFF)
  if (OJPH_DISABLE_SIMD)
    set(OJPH_ENABLE_WASM_SIMD OFF)
  else()
    set(OJPH_ENABLE_WASM_SIMD ON)
  endif()
endif()

# This is related to how the timestamp is set for URL downloaded files.
# Set DOWNLOAD_EXTRACT_TIMESTAMP
if (${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.24.0")
  if(POLICY CMP0065)
    cmake_policy(SET CMP0135 NEW)
  endif()
endif()

## Added by Michael Smith
set(CMAKE_CXX_FLAGS_ASAN
  "-fsanitize=address -fno-optimize-sibling-calls -fsanitize-address-use-after-scope -fno-omit-frame-pointer -g -O1"
  CACHE STRING "Flags used by the C++ compiler during AddressSanitizer builds."
  FORCE)

## Build type
if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release")
  message(STATUS "To use AddressSanitizer, use \"cmake .. -DCMAKE_BUILD_TYPE=asan\"" )
endif()
message(STATUS "Building ${CMAKE_BUILD_TYPE}")

## C++ version and flags
# C++14 is needed for gtest, otherwise, C++11 is sufficient for the library
set(CMAKE_CXX_STANDARD 14)
if (MSVC)
  add_compile_definitions(_CRT_SECURE_NO_WARNINGS)
endif()
if (CMAKE_CXX_COMPILER_ID MATCHES "Clang|GNU")
  add_compile_options(
  -fexceptions 
  -Wall 
  -Wextra 
  -Wconversion 
  -Wunused-parameter
  )
endif()
if (EMSCRIPTEN)
  add_compile_options(-fexceptions)
  if(OJPH_ENABLE_WASM_SIMD)
    add_compile_options(-DOJPH_ENABLE_WASM_SIMD -msimd128)
  endif()
endif()

## Enhanced instruction options
if (OJPH_DISABLE_SIMD)
  add_compile_definitions(OJPH_DISABLE_SIMD)
else()
  if(OJPH_DISABLE_SSE)
    add_compile_definitions(OJPH_DISABLE_SSE)
  endif()
  if(OJPH_DISABLE_SSE2)
    add_compile_definitions(OJPH_DISABLE_SSE2)
  endif()
  if(OJPH_DISABLE_SSSE3)
    add_compile_definitions(OJPH_DISABLE_SSSE3)
  endif()
  if(OJPH_DISABLE_SSE4)
    add_compile_definitions(OJPH_DISABLE_SSE4)
  endif()
  if(OJPH_DISABLE_AVX)
    add_compile_definitions(OJPH_DISABLE_AVX)
  endif()
  if(OJPH_DISABLE_AVX2)
    add_compile_definitions(OJPH_DISABLE_AVX2)
  endif()
  if(OJPH_DISABLE_AVX512)
    add_compile_definitions(OJPH_DISABLE_AVX512)
  endif()
  if(OJPH_DISABLE_NEON)
    add_compile_definitions(OJPH_DISABLE_NEON)
  endif()
endif()

## Build library and applications
add_subdirectory(src/core)
if (OJPH_BUILD_EXECUTABLES)
  add_subdirectory(src/apps)
endif()

################################################################################################
# Install
################################################################################################

include(GNUInstallDirs)

install(EXPORT openjph-targets
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/openjph
)

include(CMakePackageConfigHelpers)

configure_package_config_file(${CMAKE_CURRENT_SOURCE_DIR}/src/openjph-config.cmake.in
  "${CMAKE_CURRENT_BINARY_DIR}/openjph-config.cmake"
  INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/openjph
)

write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/openjph-config-version.cmake
                                 COMPATIBILITY SameMinorVersion)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/openjph-config.cmake
              ${CMAKE_CURRENT_BINARY_DIR}/openjph-config-version.cmake
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/openjph
)

if(IS_ABSOLUTE "${CMAKE_INSTALL_INCLUDEDIR}")
  set(PKG_CONFIG_INCLUDEDIR "${CMAKE_INSTALL_INCLUDEDIR}")
else()
  set(PKG_CONFIG_INCLUDEDIR "\${prefix}/${CMAKE_INSTALL_INCLUDEDIR}")
endif()

if(IS_ABSOLUTE "${CMAKE_INSTALL_LIBDIR}")
  set(PKG_CONFIG_LIBDIR "${CMAKE_INSTALL_LIBDIR}")
else()
  set(PKG_CONFIG_LIBDIR "\${prefix}/${CMAKE_INSTALL_LIBDIR}")
endif()

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/src/openjph.pc.in"
  "${CMAKE_BINARY_DIR}/${PROJECT_NAME}.pc"
  @ONLY
)

install(FILES "${CMAKE_BINARY_DIR}/${PROJECT_NAME}.pc"
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig
)

################################################################################################
# Testing (OJPH_BUILD_TESTS)
################################################################################################

if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME AND OJPH_BUILD_TESTS)
  enable_testing()
  add_subdirectory(tests)
endif()

=== src/core/CMakeLists.txt ===

file(GLOB CODESTREAM       "codestream/*.cpp" "codestream/*.h")
file(GLOB CODESTREAM_SSE   "codestream/*_sse.cpp")
file(GLOB CODESTREAM_SSE2  "codestream/*_sse2.cpp")
file(GLOB CODESTREAM_AVX   "codestream/*_avx.cpp")
file(GLOB CODESTREAM_AVX2  "codestream/*_avx2.cpp")
file(GLOB CODESTREAM_WASM  "codestream/*_wasm.cpp")
file(GLOB CODING           "coding/*.cpp" "coding/*.h")
file(GLOB CODING_SSSE3     "coding/*_ssse3.cpp")
file(GLOB CODING_WASM      "coding/*_wasm.cpp")
file(GLOB CODING_AVX2      "coding/*_avx2.cpp")
file(GLOB CODING_AVX512    "coding/*_avx512.cpp")
file(GLOB COMMON           "common/*.h")
file(GLOB OTHERS           "others/*.cpp")
file(GLOB TRANSFORM        "transform/*.cpp" "transform/*.h")
file(GLOB TRANSFORM_SSE    "transform/*_sse.cpp")
file(GLOB TRANSFORM_SSE2   "transform/*_sse2.cpp")
file(GLOB TRANSFORM_AVX    "transform/*_avx.cpp")
file(GLOB TRANSFORM_AVX2   "transform/*_avx2.cpp")
file(GLOB TRANSFORM_AVX512 "transform/*_avx512.cpp")
file(GLOB TRANSFORM_WASM   "transform/*_wasm.cpp")

list(REMOVE_ITEM CODESTREAM ${CODESTREAM_SSE} ${CODESTREAM_SSE2} ${CODESTREAM_AVX} ${CODESTREAM_AVX2} ${CODESTREAM_WASM})
list(REMOVE_ITEM CODING ${CODING_SSSE3} ${CODING_WASM} ${CODING_AVX2} ${CODING_AVX512})
list(REMOVE_ITEM TRANSFORM ${TRANSFORM_SSE} ${TRANSFORM_SSE2} ${TRANSFORM_AVX} ${TRANSFORM_AVX2} ${TRANSFORM_AVX512} ${TRANSFORM_WASM})
list(APPEND SOURCES ${CODESTREAM} ${CODING} ${COMMON} ${OTHERS} ${TRANSFORM})

source_group("codestream"        FILES ${CODESTREAM})
source_group("coding"            FILES ${CODING})
source_group("common"            FILES ${COMMON})
source_group("others"            FILES ${OTHERS})
source_group("transform"         FILES ${TRANSFORM})

if(EMSCRIPTEN)
  if (OJPH_ENABLE_WASM_SIMD)
    list(APPEND SOURCES ${CODESTREAM_WASM} ${CODING_WASM} ${TRANSFORM_WASM})
    source_group("codestream" FILES ${CODESTREAM_WASM})
    source_group("coding" FILES ${CODING_WASM})
    source_group("transform" FILES ${TRANSFORM_WASM})
  endif()
else()
  if (NOT OJPH_DISABLE_SIMD)
    if (("${OJPH_TARGET_ARCH}" MATCHES "OJPH_ARCH_X86_64") OR ("${OJPH_TARGET_ARCH}" MATCHES "OJPH_ARCH_I386"))

      if (NOT OJPH_DISABLE_SSE)
        list(APPEND SOURCES ${CODESTREAM_SSE} ${TRANSFORM_SSE})
        source_group("codestream" FILES ${CODESTREAM_SSE})
        source_group("transform" FILES ${TRANSFORM_SSE})
      endif()
      if (NOT OJPH_DISABLE_SSE2)
        list(APPEND SOURCES ${CODESTREAM_SSE2} ${TRANSFORM_SSE2})
        source_group("codestream" FILES ${CODESTREAM_SSE2})
        source_group("transform" FILES ${TRANSFORM_SSE2})
      endif()
      if (NOT OJPH_DISABLE_SSSE3)
        list(APPEND SOURCES ${CODING_SSSE3})
        source_group("coding" FILES ${CODING_SSSE3})
      endif()
      if (NOT OJPH_DISABLE_AVX)
        list(APPEND SOURCES ${CODESTREAM_AVX} ${TRANSFORM_AVX})
        source_group("codestream" FILES ${CODESTREAM_AVX})
        source_group("transform" FILES ${TRANSFORM_AVX})
      endif()
      if (NOT OJPH_DISABLE_AVX2)
        list(APPEND SOURCES ${CODESTREAM_AVX2} ${TRANSFORM_AVX2} ${CODING_AVX2})
        source_group("codestream" FILES ${CODESTREAM_AVX2})
        source_group("transform" FILES ${TRANSFORM_AVX2})
        source_group("coding" FILES ${CODING_AVX2})
      endif()
      if ((NOT OJPH_DISABLE_AVX512) AND ("${OJPH_TARGET_ARCH}" MATCHES "OJPH_ARCH_X86_64"))
        list(APPEND SOURCES ${CODING_AVX512} ${TRANSFORM_AVX512})
        source_group("coding" FILES ${CODING_AVX512})
        source_group("transform" FILES ${TRANSFORM_AVX512})
      endif()

      # Set compilation flags
      if (MSVC)
        set_source_files_properties(codestream/ojph_codestream_avx.cpp PROPERTIES COMPILE_FLAGS "/arch:AVX")
        set_source_files_properties(codestream/ojph_codestream_avx2.cpp PROPERTIES COMPILE_FLAGS "/arch:AVX2")
        set_source_files_properties(coding/ojph_block_decoder_avx2.cpp PROPERTIES COMPILE_FLAGS "/arch:AVX2")
        set_source_files_properties(coding/ojph_block_encoder_avx2.cpp PROPERTIES COMPILE_FLAGS "/arch:AVX2")
        set_source_files_properties(coding/ojph_block_encoder_avx512.cpp PROPERTIES COMPILE_FLAGS "/arch:AVX512")
        set_source_files_properties(transform/ojph_colour_avx.cpp PROPERTIES COMPILE_FLAGS "/arch:AVX")
        set_source_files_properties(transform/ojph_colour_avx2.cpp PROPERTIES COMPILE_FLAGS "/arch:AVX2")
        set_source_files_properties(transform/ojph_transform_avx.cpp PROPERTIES COMPILE_FLAGS "/arch:AVX")
        set_source_files_properties(transform/ojph_transform_avx2.cpp PROPERTIES COMPILE_FLAGS "/arch:AVX2")
        set_source_files_properties(transform/ojph_transform_avx512.cpp PROPERTIES COMPILE_FLAGS "/arch:AVX512")
      else()
        set_source_files_properties(codestream/ojph_codestream_sse.cpp PROPERTIES COMPILE_FLAGS -msse)
        set_source_files_properties(codestream/ojph_codestream_sse2.cpp PROPERTIES COMPILE_FLAGS -msse2)
        set_source_files_properties(codestream/ojph_codestream_avx.cpp PROPERTIES COMPILE_FLAGS -mavx)
        set_source_files_properties(codestream/ojph_codestream_avx2.cpp PROPERTIES COMPILE_FLAGS -mavx2)
        set_source_files_properties(coding/ojph_block_decoder_ssse3.cpp PROPERTIES COMPILE_FLAGS -mssse3)
        set_source_files_properties(coding/ojph_block_decoder_avx2.cpp PROPERTIES COMPILE_FLAGS -mavx2)
        set_source_files_properties(coding/ojph_block_encoder_avx2.cpp PROPERTIES COMPILE_FLAGS -mavx2)
        set_source_files_properties(coding/ojph_block_encoder_avx512.cpp PROPERTIES COMPILE_FLAGS -mavx512cd)
        set_source_files_properties(transform/ojph_colour_sse.cpp PROPERTIES COMPILE_FLAGS -msse)
        set_source_files_properties(transform/ojph_colour_sse2.cpp PROPERTIES COMPILE_FLAGS -msse2)
        set_source_files_properties(transform/ojph_colour_avx.cpp PROPERTIES COMPILE_FLAGS -mavx)
        set_source_files_properties(transform/ojph_colour_avx2.cpp PROPERTIES COMPILE_FLAGS -mavx2)
        set_source_files_properties(transform/ojph_transform_sse.cpp PROPERTIES COMPILE_FLAGS -msse)
        set_source_files_properties(transform/ojph_transform_sse2.cpp PROPERTIES COMPILE_FLAGS -msse2)
        set_source_files_properties(transform/ojph_transform_avx.cpp PROPERTIES COMPILE_FLAGS -mavx)
        set_source_files_properties(transform/ojph_transform_avx2.cpp PROPERTIES COMPILE_FLAGS -mavx2)
        set_source_files_properties(transform/ojph_transform_avx512.cpp PROPERTIES COMPILE_FLAGS -mavx512f)
      endif()

    elseif ("${OJPH_TARGET_ARCH}" MATCHES "OJPH_ARCH_ARM")

    endif()

  endif()


endif()

add_library(openjph ${SOURCES})

## The option BUILD_SHARED_LIBS
if (BUILD_SHARED_LIBS AND WIN32)
  target_compile_definitions(openjph PRIVATE OJPH_BUILD_SHARED_LIBRARY)
endif()

## include library version/name
target_compile_definitions(openjph PUBLIC _FILE_OFFSET_BITS=64)
target_include_directories(openjph PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/common> $<INSTALL_INTERFACE:include/openjph>)

if (MSVC)
  set(OJPH_LIB_NAME_STRING "openjph.${OPENJPH_VERSION_MAJOR}.${OPENJPH_VERSION_MINOR}")
  set_target_properties(openjph
    PROPERTIES
      OUTPUT_NAME "openjph.${OPENJPH_VERSION_MAJOR}.${OPENJPH_VERSION_MINOR}")
else()
  set(OJPH_LIB_NAME_STRING "openjph.${OPENJPH_VERSION_MAJOR}.${OPENJPH_VERSION_MINOR}")
  set_target_properties(openjph
    PROPERTIES
      SOVERSION "${OPENJPH_VERSION_MAJOR}.${OPENJPH_VERSION_MINOR}"
      VERSION "${OPENJPH_VERSION}")
endif()

install(TARGETS openjph
  EXPORT openjph-targets
)

install(DIRECTORY common/
  DESTINATION include/openjph
  FILES_MATCHING
  PATTERN "*.h"
)

=== src/apps/ojph_compress/CMakeLists.txt ===
## building ojph_compress
#########################

file(GLOB OJPH_COMPRESS       "ojph_compress.cpp")
file(GLOB OJPH_IMG_IO         "../others/ojph_img_io.cpp")
file(GLOB OJPH_IMG_IO_SSE4    "../others/ojph_img_io_sse41.cpp")
file(GLOB OJPH_IMG_IO_AVX2    "../others/ojph_img_io_avx2.cpp")
file(GLOB OJPH_IMG_IO_H       "../common/ojph_img_io.h")

list(APPEND SOURCES ${OJPH_COMPRESS} ${OJPH_IMG_IO} ${OJPH_IMG_IO_H})

source_group("main"        FILES ${OJPH_COMPRESS})
source_group("others"      FILES ${OJPH_IMG_IO})
source_group("common"      FILES ${OJPH_IMG_IO_H})

if(EMSCRIPTEN)
  if (OJPH_ENABLE_WASM_SIMD)
    list(APPEND SOURCES ${OJPH_IMG_IO_SSE4})
    source_group("others" FILES ${OJPH_IMG_IO_SSE4})
    set_source_files_properties(${OJPH_IMG_IO_SSE4} PROPERTIES COMPILE_FLAGS -msse4.1)
  endif()
else()
  if (NOT OJPH_DISABLE_SIMD)
    if (("${OJPH_TARGET_ARCH}" MATCHES "OJPH_ARCH_X86_64") OR ("${OJPH_TARGET_ARCH}" MATCHES "OJPH_ARCH_I386"))
      if (NOT OJPH_DISABLE_SSE4)
        list(APPEND SOURCES ${OJPH_IMG_IO_SSE4})
        source_group("others" FILES ${OJPH_IMG_IO_SSE4})
      endif()
      if (NOT OJPH_DISABLE_AVX2)
        list(APPEND SOURCES ${OJPH_IMG_IO_AVX2})
        source_group("others" FILES ${OJPH_IMG_IO_AVX2})
      endif()

      # Set compilation flags
      if (MSVC)
        set_source_files_properties(${OJPH_IMG_IO_AVX2} PROPERTIES COMPILE_FLAGS "/arch:AVX2")
      else()
        set_source_files_properties(${OJPH_IMG_IO_SSE4} PROPERTIES COMPILE_FLAGS -msse4.1)
        set_source_files_properties(${OJPH_IMG_IO_AVX2} PROPERTIES COMPILE_FLAGS -mavx2)
      endif()
    elseif ("${OJPH_TARGET_ARCH}" MATCHES "OJPH_ARCH_ARM")

    endif()

  endif()

endif()

add_executable(ojph_compress ${SOURCES})
target_include_directories(ojph_compress PRIVATE ../common)
target_link_libraries(ojph_compress PRIVATE openjph $<TARGET_NAME_IF_EXISTS:TIFF::TIFF>)

install(TARGETS ojph_compress)

=== src/apps/ojph_expand/CMakeLists.txt ===
## building ojph_expand
#######################

file(GLOB OJPH_EXPAND         "ojph_expand.cpp")
file(GLOB OJPH_IMG_IO         "../others/ojph_img_io.cpp")
file(GLOB OJPH_IMG_IO_SSE4    "../others/ojph_img_io_sse41.cpp")
file(GLOB OJPH_IMG_IO_AVX2    "../others/ojph_img_io_avx2.cpp")
file(GLOB OJPH_IMG_IO_H       "../common/ojph_img_io.h")

list(APPEND SOURCES ${OJPH_EXPAND} ${OJPH_IMG_IO} ${OJPH_IMG_IO_H})

source_group("main"        FILES ${OJPH_EXPAND})
source_group("others"      FILES ${OJPH_IMG_IO})
source_group("common"      FILES ${OJPH_IMG_IO_H})

if(EMSCRIPTEN)
  if (OJPH_ENABLE_WASM_SIMD)
    list(APPEND SOURCES ${OJPH_IMG_IO_SSE4})
    source_group("others" FILES ${OJPH_IMG_IO_SSE4})
    set_source_files_properties(${OJPH_IMG_IO_SSE4} PROPERTIES COMPILE_FLAGS -msse4.1)
  endif()
else()
  if (NOT OJPH_DISABLE_SIMD)
    if (("${OJPH_TARGET_ARCH}" MATCHES "OJPH_ARCH_X86_64") OR ("${OJPH_TARGET_ARCH}" MATCHES "OJPH_ARCH_I386"))
      if (NOT OJPH_DISABLE_SSE4)
        list(APPEND SOURCES ${OJPH_IMG_IO_SSE4})
        source_group("others" FILES ${OJPH_IMG_IO_SSE4})
      endif()
      if (NOT OJPH_DISABLE_AVX2)
        list(APPEND SOURCES ${OJPH_IMG_IO_AVX2})
        source_group("others" FILES ${OJPH_IMG_IO_AVX2})
      endif()

      # Set compilation flags
      if (MSVC)
        set_source_files_properties(${OJPH_IMG_IO_AVX2} PROPERTIES COMPILE_FLAGS "/arch:AVX2")
      else()
        set_source_files_properties(${OJPH_IMG_IO_SSE4} PROPERTIES COMPILE_FLAGS -msse4.1)
        set_source_files_properties(${OJPH_IMG_IO_AVX2} PROPERTIES COMPILE_FLAGS -mavx2)
      endif()
    elseif ("${OJPH_TARGET_ARCH}" MATCHES "OJPH_ARCH_ARM")

    endif()

  endif()

endif()

add_executable(ojph_expand ${SOURCES})
target_include_directories(ojph_expand PRIVATE ../common)
target_link_libraries(ojph_expand PRIVATE openjph $<TARGET_NAME_IF_EXISTS:TIFF::TIFF>)

install(TARGETS ojph_expand)

=== debian/changelog ===
openjph (0.21.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 0.21.2
  * Bump Standards-Version: 4.7.2

 -- xiao sheng wen <atzlinux@debian.org>  Tue, 22 Apr 2025 10:51:10 +0800

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

include /usr/share/dpkg/default.mk

export DPKG_GENSYMBOLS_CHECK_LEVEL = 4
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=+lto

%:
	dh $@

ifeq ($(DEB_BUILD_ARCH),$(filter $(DEB_BUILD_ARCH),amd64 x32))
  CMAKE_EXTRA_FLAGS += -DOJPH_DISABLE_SIMD:BOOL=OFF
else
  CMAKE_EXTRA_FLAGS += -DOJPH_DISABLE_SIMD:BOOL=ON
endif

CMAKE_EXTRA_FLAGS += \
	-DBUILD_SHARED_LIBS:BOOL=ON \

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_EXTRA_FLAGS)

execute_after_dh_auto_build:
	cd docs && doxygen

execute_before_dh_installman:
	help2man --version-string=$(DEB_VERSION_UPSTREAM) --help-option=" " --include=debian/ojph_compress.1.in --output=debian/ojph_compress.1  --no-info --no-discard-stderr ./debian/tmp/usr/bin/ojph_compress
	help2man --version-string=$(DEB_VERSION_UPSTREAM) --help-option=" " --include=debian/ojph_expand.1.in --output=debian/ojph_expand.1  --no-info --no-discard-stderr ./debian/tmp/usr/bin/ojph_expand

## openjph 0.21.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.11.0)
+cmake_minimum_required(VERSION 3.12.0)
 
 ## Library name/version
 include(ojph_version.cmake)
@@ -18,6 +18,22 @@
 include(target_arch.cmake)
 target_architecture(OJPH_TARGET_ARCH)
 message(STATUS "CPU Architecture is ${OJPH_TARGET_ARCH}")
+
+## Building for multi-generation
+# This is useful for when we are building a multi-architecture build, such as when using
+# the -DCMAKE_OSX_ARCHITECTURES="arm64;x86_64" build configuration
+if (CMAKE_OSX_ARCHITECTURES)
+  list(FIND CMAKE_OSX_ARCHITECTURES "x86_64" x86_64_index)
+  if (${x86_64_index} GREATER -1)
+    set(MULTI_GEN_X86_64 TRUE)
+  endif()
+  unset(x86_64_index)
+  list(FIND CMAKE_OSX_ARCHITECTURES "arm64" arm64_index)
+  if (${arm64_index} GREATER -1)
+    set(MULTI_GEN_ARM64 TRUE)
+  endif()
+  unset(arm64_index)
+endif()
 
 ## options
 option(BUILD_SHARED_LIBS "Shared Libraries" ON)

=== tests/CMakeLists.txt ===

# Fetch googletest
include(FetchContent)
FetchContent_Declare(
  googletest
  URL https://github.com/google/googletest/archive/refs/tags/v1.14.0.tar.gz
  EXCLUDE_FROM_ALL
)
# For Windows: Prevent overriding the parent project's compiler/linker settings
set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
set(BUILD_GMOCK OFF CACHE BOOL "" FORCE)
option(INSTALL_GTEST "Enable installation of googletest." OFF)
FetchContent_MakeAvailable(googletest)

# Fetch test files
FetchContent_Declare(
  jp2k_test_codestreams
  URL               https://github.com/aous72/jp2k_test_codestreams/archive/refs/heads/main.zip
  SOURCE_DIR        jp2k_test_codestreams/
)
FetchContent_MakeAvailable(jp2k_test_codestreams)

# create the mse_pae executable
include(mse_pae.cmake)

# create the compare_files executable
add_executable(
  compare_files
  compare_files.cpp
)

# configure test executables
add_executable(
  test_executables
  test_executables.cpp
)

target_link_libraries(
  test_executables
  GTest::gtest_main
)

include(GoogleTest)
gtest_add_tests(TARGET test_executables)

if (MSVC)
  add_custom_command(TARGET test_executables POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy "../bin/\$(Configuration)/gtest.dll" "./"
    COMMAND ${CMAKE_COMMAND} -E copy "../bin/\$(Configuration)/gtest_main.dll" "./"
    COMMAND ${CMAKE_COMMAND} -E copy "$<TARGET_FILE:ojph_compress>" "./"
    COMMAND ${CMAKE_COMMAND} -E copy "$<TARGET_FILE:ojph_expand>" "./"
    COMMAND ${CMAKE_COMMAND} -E copy "$<TARGET_FILE:openjph>" "./"
  )
  add_custom_command(TARGET compare_files POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy "./\$(Configuration)/compare_files.exe" "./"
  )
  add_custom_command(TARGET mse_pae POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy "./\$(Configuration)/mse_pae.exe" "./"
  )
  if (MSVC AND OJPH_ENABLE_TIFF_SUPPORT)
      file(COPY "${TIFF_INCLUDE_DIR}\\..\\bin\\tiff.dll" DESTINATION "./")
      file(COPY "${TIFF_INCLUDE_DIR}\\..\\bin\\tiffxx.dll" DESTINATION "./")
      file(COPY "${TIFF_INCLUDE_DIR}\\..\\bin\\tiffd.dll" DESTINATION "./")
      file(COPY "${TIFF_INCLUDE_DIR}\\..\\bin\\tiffxxd.dll" DESTINATION "./")
  endif() 
else()
  add_custom_command(TARGET test_executables POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy "$<TARGET_FILE:ojph_expand>" "./"
    COMMAND ${CMAKE_COMMAND} -E copy "$<TARGET_FILE:ojph_compress>" "./"
  )
  if(EMSCRIPTEN)
    add_custom_command(TARGET test_executables POST_BUILD
      COMMAND ${CMAKE_COMMAND} -E copy "$<TARGET_FILE_DIR:ojph_expand>/ojph_expand.wasm" "./"
      COMMAND ${CMAKE_COMMAND} -E copy "$<TARGET_FILE_DIR:ojph_compress>/ojph_compress.wasm" "./"
    )
  endif(EMSCRIPTEN)
  if(MSYS)
    add_custom_command(TARGET test_executables POST_BUILD
      COMMAND ${CMAKE_COMMAND} -E copy "../bin/msys-gtest.dll" "./"
      COMMAND ${CMAKE_COMMAND} -E copy "../bin/msys-gtest_main.dll" "./"
    )
  endif(MSYS)
endif(MSVC)

=== src/core/CMakeLists.txt ===
--- 
+++ 
@@ -40,7 +40,9 @@
   endif()
 else()
   if (NOT OJPH_DISABLE_SIMD)
-    if (("${OJPH_TARGET_ARCH}" MATCHES "OJPH_ARCH_X86_64") OR ("${OJPH_TARGET_ARCH}" MATCHES "OJPH_ARCH_I386"))
+    if (("${OJPH_TARGET_ARCH}" MATCHES "OJPH_ARCH_X86_64")
+      OR ("${OJPH_TARGET_ARCH}" MATCHES "OJPH_ARCH_I386")
+      OR MULTI_GEN_X86_64)
 
       if (NOT OJPH_DISABLE_SSE)
         list(APPEND SOURCES ${CODESTREAM_SSE} ${TRANSFORM_SSE})
@@ -67,7 +69,7 @@
         source_group("transform" FILES ${TRANSFORM_AVX2})
         source_group("coding" FILES ${CODING_AVX2})
       endif()
-      if ((NOT OJPH_DISABLE_AVX512) AND ("${OJPH_TARGET_ARCH}" MATCHES "OJPH_ARCH_X86_64"))
+      if (NOT OJPH_DISABLE_AVX512)
         list(APPEND SOURCES ${CODING_AVX512} ${TRANSFORM_AVX512})
         source_group("coding" FILES ${CODING_AVX512})
         source_group("transform" FILES ${TRANSFORM_AVX512})
@@ -93,7 +95,7 @@
         set_source_files_properties(coding/ojph_block_decoder_ssse3.cpp PROPERTIES COMPILE_FLAGS -mssse3)
         set_source_files_properties(coding/ojph_block_decoder_avx2.cpp PROPERTIES COMPILE_FLAGS -mavx2)
         set_source_files_properties(coding/ojph_block_encoder_avx2.cpp PROPERTIES COMPILE_FLAGS -mavx2)
-        set_source_files_properties(coding/ojph_block_encoder_avx512.cpp PROPERTIES COMPILE_FLAGS -mavx512cd)
+        set_source_files_properties(coding/ojph_block_encoder_avx512.cpp PROPERTIES COMPILE_FLAGS "-mavx512f -mavx512cd")
         set_source_files_properties(transform/ojph_colour_sse.cpp PROPERTIES COMPILE_FLAGS -msse)
         set_source_files_properties(transform/ojph_colour_sse2.cpp PROPERTIES COMPILE_FLAGS -msse2)
         set_source_files_properties(transform/ojph_colour_avx.cpp PROPERTIES COMPILE_FLAGS -mavx)
@@ -102,15 +104,15 @@
         set_source_files_properties(transform/ojph_transform_sse2.cpp PROPERTIES COMPILE_FLAGS -msse2)
         set_source_files_properties(transform/ojph_transform_avx.cpp PROPERTIES COMPILE_FLAGS -mavx)
         set_source_files_properties(transform/ojph_transform_avx2.cpp PROPERTIES COMPILE_FLAGS -mavx2)
-        set_source_files_properties(transform/ojph_transform_avx512.cpp PROPERTIES COMPILE_FLAGS -mavx512f)
+        set_source_files_properties(transform/ojph_transform_avx512.cpp PROPERTIES COMPILE_FLAGS "-mavx512f -mavx512cd")
       endif()
+    endif()
 
-    elseif ("${OJPH_TARGET_ARCH}" MATCHES "OJPH_ARCH_ARM")
+    if (("${OJPH_TARGET_ARCH}" MATCHES "OJPH_ARCH_ARM") OR MULTI_GEN_ARM64)
 
     endif()
 
   endif()
-
 
 endif()
 
@@ -122,6 +124,9 @@
 endif()
 
 ## include library version/name
+if (NOT MSVC)
+  target_compile_options(openjph PRIVATE -fPIC)
+endif()
 target_compile_definitions(openjph PUBLIC _FILE_OFFSET_BITS=64)
 target_include_directories(openjph PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/common> $<INSTALL_INTERFACE:include/openjph>)

=== subprojects/js/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.0)

set(CMAKE_SYSTEM_NAME Generic)

project (OpenJPH_WASM DESCRIPTION "Open source implementation of JPH" LANGUAGES CXX)

add_subdirectory("../.." openjph EXCLUDE_FROM_ALL)
add_executable(libopenjph "src/ojph_wrapper.cpp")
if (OJPH_DISABLE_SIMD)
else()
  target_compile_options(libopenjph PRIVATE -DOJPH_ENABLE_WASM_SIMD -msimd128)
endif()
set_target_properties(libopenjph PROPERTIES SUFFIX ".js")
target_link_options(libopenjph PRIVATE
  -fexceptions
  -sWASM=1
  -sEXPORT_ES6=1
  -sMODULARIZE=1
  -sENVIRONMENT=web
  -sEXPORTED_FUNCTIONS=[_free,_malloc]
  -sEXPORTED_RUNTIME_METHODS=[ccall,cwrap,writeArrayToMemory]
  -sNO_EXIT_RUNTIME=1
  -sALLOW_MEMORY_GROWTH=1
  -sINITIAL_MEMORY=134217728
)
target_link_libraries(libopenjph PRIVATE openjph)

=== src/apps/ojph_compress/CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,10 @@
   endif()
 else()
   if (NOT OJPH_DISABLE_SIMD)
-    if (("${OJPH_TARGET_ARCH}" MATCHES "OJPH_ARCH_X86_64") OR ("${OJPH_TARGET_ARCH}" MATCHES "OJPH_ARCH_I386"))
+    if (("${OJPH_TARGET_ARCH}" MATCHES "OJPH_ARCH_X86_64") 
+      OR ("${OJPH_TARGET_ARCH}" MATCHES "OJPH_ARCH_I386")
+      OR MULTI_GEN_X86_64)
+
       if (NOT OJPH_DISABLE_SSE4)
         list(APPEND SOURCES ${OJPH_IMG_IO_SSE4})
         source_group("others" FILES ${OJPH_IMG_IO_SSE4})
@@ -38,7 +41,9 @@
         set_source_files_properties(${OJPH_IMG_IO_SSE4} PROPERTIES COMPILE_FLAGS -msse4.1)
         set_source_files_properties(${OJPH_IMG_IO_AVX2} PROPERTIES COMPILE_FLAGS -mavx2)
       endif()
-    elseif ("${OJPH_TARGET_ARCH}" MATCHES "OJPH_ARCH_ARM")
+    endif()
+
+    if (("${OJPH_TARGET_ARCH}" MATCHES "OJPH_ARCH_ARM") OR MULTI_GEN_ARM64)
 
     endif()

=== src/apps/ojph_stream_expand/CMakeLists.txt ===
## building ojph_stream_expand
##############################

set(CMAKE_CXX_STANDARD 14)

file(GLOB OJPH_STREAM_EXPAND  "*.cpp" "*.h")
file(GLOB OJPH_SOCKETS         "../others/ojph_sockets.cpp")
file(GLOB OJPH_SOCKETS_H       "../common/ojph_sockets.h")
file(GLOB OJPH_THREADS        "../others/ojph_threads.cpp")
file(GLOB OJPH_THREADS_H      "../common/ojph_threads.h")

list(APPEND SOURCES ${OJPH_STREAM_EXPAND} ${OJPH_SOCKETS} ${OJPH_SOCKETS_H} ${OJPH_THREADS} ${OJPH_THREADS_H})

source_group("main"        FILES ${OJPH_STREAM_EXPAND})
source_group("others"      FILES ${OJPH_SOCKETS} ${OJPH_THREADS})
source_group("common"      FILES ${OJPH_SOCKETS_H} ${OJPH_THREADS_H})

add_executable(ojph_stream_expand ${SOURCES})
target_include_directories(ojph_stream_expand PRIVATE ../common)
if(MSVC)
    target_link_libraries(ojph_stream_expand PUBLIC openjph ws2_32)
else()
    target_link_libraries(ojph_stream_expand PUBLIC openjph pthread)
endif(MSVC)

install(TARGETS ojph_stream_expand)

=== debian/changelog ===
openjph (0.21.5-2) unstable; urgency=medium

  * Team upload.
  * d/rules: add LD_PRELOAD for help2man, Closes: #1119712

 -- xiao sheng wen <atzlinux@debian.org>  Fri, 31 Oct 2025 22:49:08 +0800

openjph (0.21.5-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 0.21.5

 -- xiao sheng wen <atzlinux@debian.org>  Fri, 15 Aug 2025 09:56:36 +0800

=== debian/control ===
Source: openjph
Section: libs
Priority: optional
Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders: Mathieu Malaterre <malat@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               help2man,
               libtiff-dev,
               doxygen,
Standards-Version: 4.7.2
Homepage: https://github.com/aous72/OpenJPH
Vcs-Git: https://salsa.debian.org/debian-phototools-team/openjph.git
Vcs-Browser: https://salsa.debian.org/debian-phototools-team/openjph
Rules-Requires-Root: no

Package: libopenjph0.21
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: HTJ2K image compression/decompression library (runtime files)
 Implementation of High-throughput JPEG2000 (HTJ2K), also known as JPH, JPEG2000
 Part 15, ISO/IEC 15444-15, and ITU-T T.814. This library only implements HTJ2K
 only, supporting features that are defined in JPEG2000 Part 1 (for example, for
 wavelet transform, only reversible 5/3 and irreversible 9/7 are supported).
 .
 This package installs the runtime files.

Package: libopenjph-dev
Architecture: any
Section: libdevel
Pre-Depends: ${misc:Pre-Depends}
Depends: libopenjph0.21 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: HTJ2K image compression/decompression library (developer files)
 Implementation of High-throughput JPEG2000 (HTJ2K), also known as JPH, JPEG2000
 Part 15, ISO/IEC 15444-15, and ITU-T T.814. This library only implements HTJ2K
 only, supporting features that are defined in JPEG2000 Part 1 (for example, for
 wavelet transform, only reversible 5/3 and irreversible 9/7 are supported).
 .
 This package installs the development files.

Package: openjph-tools
Architecture: any
Section: graphics
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: HTJ2K image compression/decompression library (command line tools)
 Implementation of High-throughput JPEG2000 (HTJ2K), also known as JPH, JPEG2000
 Part 15, ISO/IEC 15444-15, and ITU-T T.814. This library only implements HTJ2K
 only, supporting features that are defined in JPEG2000 Part 1 (for example, for
 wavelet transform, only reversible 5/3 and irreversible 9/7 are supported).
 .
 This package installs the command line utilities.

Package: openjph-doc
Architecture: all
Section: doc
Depends: doc-base, ${misc:Depends}
Description: HTJ2K image compression/decompression library (documentation files)
 Implementation of High-throughput JPEG2000 (HTJ2K), also known as JPH, JPEG2000
 Part 15, ISO/IEC 15444-15, and ITU-T T.814. This library only implements HTJ2K
 only, supporting features that are defined in JPEG2000 Part 1 (for example, for
 wavelet transform, only reversible 5/3 and irreversible 9/7 are supported).
 .
 This package installs the documentation files.

=== debian/rules ===
--- 
+++ 
@@ -25,5 +25,5 @@
 	cd docs && doxygen
 
 execute_before_dh_installman:
-	help2man --version-string=$(DEB_VERSION_UPSTREAM) --help-option=" " --include=debian/ojph_compress.1.in --output=debian/ojph_compress.1  --no-info --no-discard-stderr ./debian/tmp/usr/bin/ojph_compress
-	help2man --version-string=$(DEB_VERSION_UPSTREAM) --help-option=" " --include=debian/ojph_expand.1.in --output=debian/ojph_expand.1  --no-info --no-discard-stderr ./debian/tmp/usr/bin/ojph_expand
+	LD_PRELOAD= LD_LIBRARY_PATH=./debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) help2man --version-string=$(DEB_VERSION_UPSTREAM) --help-option=" " --include=debian/ojph_compress.1.in --output=debian/ojph_compress.1  --no-info --no-discard-stderr ./debian/tmp/usr/bin/ojph_compress
+	LD_PRELOAD= LD_LIBRARY_PATH=./debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) help2man --version-string=$(DEB_VERSION_UPSTREAM) --help-option=" " --include=debian/ojph_expand.1.in --output=debian/ojph_expand.1  --no-info --no-discard-stderr ./debian/tmp/usr/bin/ojph_expand

## openjph 0.25.3

=== src/core/CMakeLists.txt ===
--- 
+++ 
@@ -11,7 +11,7 @@
 file(GLOB CODING_AVX2      "coding/*_avx2.cpp")
 file(GLOB CODING_AVX512    "coding/*_avx512.cpp")
 file(GLOB COMMON           "common/*.h")
-file(GLOB OTHERS           "others/*.cpp")
+file(GLOB OTHERS           "others/*.cpp" "others/*.c")
 file(GLOB TRANSFORM        "transform/*.cpp" "transform/*.h")
 file(GLOB TRANSFORM_SSE    "transform/*_sse.cpp")
 file(GLOB TRANSFORM_SSE2   "transform/*_sse2.cpp")
@@ -116,6 +116,17 @@
 
 endif()
 
+## Set debug postfix for different platforms
+if (MSVC)
+  if (NOT DEFINED CMAKE_DEBUG_POSTFIX)
+    set(CMAKE_DEBUG_POSTFIX "d")
+  endif()
+elseif (CMAKE_CXX_COMPILER_ID MATCHES "Clang|GNU")
+  if (NOT DEFINED CMAKE_DEBUG_POSTFIX)
+    set(CMAKE_DEBUG_POSTFIX "_d")
+  endif()
+endif()
+
 add_library(openjph ${SOURCES})
 
 ## The option BUILD_SHARED_LIBS
@@ -124,11 +135,26 @@
 endif()
 
 ## include library version/name
+set_target_properties(openjph PROPERTIES POSITION_INDEPENDENT_CODE ON)
+target_compile_definitions(openjph PUBLIC _FILE_OFFSET_BITS=64)
+target_include_directories(openjph PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/common> $<INSTALL_INTERFACE:include>)
+
+## This is to check if aligned_alloc or posix_memalign is available
+# We want the code to compile for C11 and C++11.
+# std::aligned_alloc is only availabe in C++17.
+# So here we try to see which API is available and adapt the code to use it
 if (NOT MSVC)
-  target_compile_options(openjph PRIVATE -fPIC)
+  include(CheckSymbolExists)
+  check_symbol_exists(aligned_alloc "stdlib.h" OJPH_ALIGNED_ALLOC_EXISTS)
+  if (OJPH_ALIGNED_ALLOC_EXISTS)
+    target_compile_definitions(openjph PRIVATE OJPH_ALIGNED_ALLOC_EXISTS)
+  else()
+    check_symbol_exists(posix_memalign "stdlib.h" OJPH_POSIX_MEMALIGN_EXISTS)
+    if (OJPH_POSIX_MEMALIGN_EXISTS)
+      target_compile_definitions(openjph PRIVATE OJPH_POSIX_MEMALIGN_EXISTS)
+    endif()
+  endif()
 endif()
-target_compile_definitions(openjph PUBLIC _FILE_OFFSET_BITS=64)
-target_include_directories(openjph PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/common> $<INSTALL_INTERFACE:include/openjph>)
 
 if (MSVC)
   set(OJPH_LIB_NAME_STRING "openjph.${OPENJPH_VERSION_MAJOR}.${OPENJPH_VERSION_MINOR}")

=== debian/changelog ===
openjph (0.25.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 0.25.3
  * d/control:
      - delete Rules-Requires-Root: no, useless
      - Bump SOVERSION to 0.25, update binary package name to libopenjph0.25
  * rename d/libopenjph0.21.install to d/libopenjph0.25.install

 -- xiao sheng wen <atzlinux@debian.org>  Tue, 09 Dec 2025 09:13:26 +0800

=== debian/control ===
--- 
+++ 
@@ -12,9 +12,8 @@
 Homepage: https://github.com/aous72/OpenJPH
 Vcs-Git: https://salsa.debian.org/debian-phototools-team/openjph.git
 Vcs-Browser: https://salsa.debian.org/debian-phototools-team/openjph
-Rules-Requires-Root: no
 
-Package: libopenjph0.21
+Package: libopenjph0.25
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
@@ -31,7 +30,7 @@
 Architecture: any
 Section: libdevel
 Pre-Depends: ${misc:Pre-Depends}
-Depends: libopenjph0.21 (= ${binary:Version}), ${misc:Depends}
+Depends: libopenjph0.25 (= ${binary:Version}), ${misc:Depends}
 Multi-Arch: same
 Description: HTJ2K image compression/decompression library (developer files)
  Implementation of High-throughput JPEG2000 (HTJ2K), also known as JPH, JPEG2000

## openjph 0.26.0

=== src/core/CMakeLists.txt ===
--- 
+++ 
@@ -10,7 +10,7 @@
 file(GLOB CODING_WASM      "coding/*_wasm.cpp")
 file(GLOB CODING_AVX2      "coding/*_avx2.cpp")
 file(GLOB CODING_AVX512    "coding/*_avx512.cpp")
-file(GLOB COMMON           "common/*.h")
+file(GLOB COMMON           "openjph/*.h")
 file(GLOB OTHERS           "others/*.cpp" "others/*.c")
 file(GLOB TRANSFORM        "transform/*.cpp" "transform/*.h")
 file(GLOB TRANSFORM_SSE    "transform/*_sse.cpp")
@@ -137,7 +137,7 @@
 ## include library version/name
 set_target_properties(openjph PROPERTIES POSITION_INDEPENDENT_CODE ON)
 target_compile_definitions(openjph PUBLIC _FILE_OFFSET_BITS=64)
-target_include_directories(openjph PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/common> $<INSTALL_INTERFACE:include>)
+target_include_directories(openjph PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/openjph> $<INSTALL_INTERFACE:include>)
 
 ## This is to check if aligned_alloc or posix_memalign is available
 # We want the code to compile for C11 and C++11.
@@ -173,7 +173,7 @@
   EXPORT openjph-targets
 )
 
-install(DIRECTORY common/
+install(DIRECTORY openjph/
   DESTINATION include/openjph
   FILES_MATCHING
   PATTERN "*.h"

=== debian/changelog ===
openjph (0.26.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 0.26.0
  * d/control: Bump SOVERSION to 0.26
      - update binary package name to libopenjph0.26
      - set Package: libopenjph-dev Depends: libopenjph0.26
  * rename debian/libopenjph0.25.install debian/libopenjph0.26.install

 -- xiao sheng wen <atzlinux@debian.org>  Tue, 30 Dec 2025 09:52:57 +0800

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
 Vcs-Git: https://salsa.debian.org/debian-phototools-team/openjph.git
 Vcs-Browser: https://salsa.debian.org/debian-phototools-team/openjph
 
-Package: libopenjph0.25
+Package: libopenjph0.26
 Architecture: any
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
@@ -30,7 +30,7 @@
 Architecture: any
 Section: libdevel
 Pre-Depends: ${misc:Pre-Depends}
-Depends: libopenjph0.25 (= ${binary:Version}), ${misc:Depends}
+Depends: libopenjph0.26 (= ${binary:Version}), ${misc:Depends}
 Multi-Arch: same
 Description: HTJ2K image compression/decompression library (developer files)
  Implementation of High-throughput JPEG2000 (HTJ2K), also known as JPH, JPEG2000

## openjph 0.26.3

=== debian/changelog ===
openjph (0.26.3-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 0.26.3
  * Bump Standards-Version: 4.7.3
  * d/copyright: update year info to 2026

 -- xiao sheng wen <atzlinux@debian.org>  Tue, 24 Feb 2026 10:05:14 +0800

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
                help2man,
                libtiff-dev,
                doxygen,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://github.com/aous72/OpenJPH
 Vcs-Git: https://salsa.debian.org/debian-phototools-team/openjph.git
 Vcs-Browser: https://salsa.debian.org/debian-phototools-team/openjph
